#ifndef __SCRIPT_700__PARSER__
#define __SCRIPT_700__PARSER__

#include <foobar2000.h>
#include "Types.h"

class script700_parser
{
  public:

	script700_parser();
	script700_parser(u8 *&pProgram, u32 *&pWork, u8 *&pDSPFlag, u8 *&pChange, u32 *&pDetune);
	bool load(file_info *info);
	void* get_ptr();
	bool parse();

  private:
	char* skip_space(char *&);
	int get_num(char *&);
	char* next_line(char *&);
	char* get_line(char *&);
	char* get_command(char *&);
	char* get_ex_command(char *&);
	bool get_value(char *&, int);

  private:
	// Script700 work.
	u8 *m_pProgram;
	u32 *m_pWork;
	u8 *m_pDSPFlag;
	u8 *m_pChange;
	u32 *m_pDetune;

	mem_block_t<char> m_aScriptBuf;

	// Parse work.
	bool m_bExtendFlag;		// gR}h[htO
	u16 m_aLabel[1000];		// Lable 0-999
	int m_program_index;	// m_pProgram̏ݐCfbNX
};

#endif
